//---------------------------------------------------------------------------
// Copyright 1999 Andreas Huennebeck
//
// $Source: /home/ah/CvsTree/daten/src/libAHstl/TestDel.c,v $
// $Id: TestDel.c,v 1.4 2003/03/18 01:00:14 ah Exp $
//
// Description: 
//
//---------------------------------------------------------------------------

static const char rcsid[] = "$Id: TestDel.c,v 1.4 2003/03/18 01:00:14 ah Exp $ (c) 1999 Andreas Huennebeck";

// --- necessary includes ---

#include <AH/STL/String.h>		// my interface first, says Lakos

USING_NAMESPACE(AH)

#include<iostream>
USING_NAMESPACE(std)

enum {source,foll,lead,surr};
static string test[][5] =		// test strings
{
    { "without WS", "without WS", "without WS", "without WS" },
    { "following WS \t", "following WS", "following WS \t", "following WS"},
    { "\t leading WS", "\t leading WS", "leading WS", "leading WS"},
    { "\t surround WS \t", "\t surround WS", "surround WS \t", "surround WS"},
    { "\t\t", "", "", ""}
};



int main(int argc, char *argv[])
{
    cout << "Test of string handling functions in String.c:"
	 << endl;

    unsigned int testnum = 0;

    //-----------------------------
    // scan command line options :
    //-----------------------------
    bool debug(false);
    if ((argc > 1) && (0 == strcmp(argv[1],"-d"))) debug = true;

    //-------------
    // run tests :
    //-------------
    unsigned int errnum[3] = {0,0,0};
    unsigned int i;
    for (i = 0; i < sizeof(test)/sizeof(test[0]); i++)
    {
	string s;

	//------------------------------
	// test STLStringDelFollow :
	//------------------------------
	s = test[i][source];
        STLStringDelFollow(s);
	testnum++;
        if (debug) cout << "STLStringDelFollow(\"" << test[i][source] 
			<< "\") = \"" << s << "\"" << endl;
	if (s != test[i][foll])
	{
	    cout << "- Error in STLStringDelFollow(\"" << test[i][source] 
		 << "\"):\n  is \"" << s << "\", should be \"" <<
		 test[i][foll] << "\"" << endl;
	    errnum[foll-1]++;
	}

	//----------------------------
	// test STLStringDelLead :
	//----------------------------
	s = test[i][source];
        STLStringDelLead(s);
	testnum++;
        if (debug) cout << "STLStringDelLead(\"" << test[i][source] 
			<< "\") = \"" << s << "\"" << endl;
	if (s != test[i][lead])
	{
	    cout << "- Error in STLStringDelLead(\"" << test[i][source] 
		 << "\"):\n  is \"" << s << "\", should be \"" <<
		 test[i][lead] << "\"" << endl;
	    errnum[lead-1]++;
	}

	//--------------------------------
	// test STLStringDelSurround :
	//--------------------------------
	s = test[i][source];
        STLStringDelSurround(s);
	testnum++;
        if (debug) cout << "STLStringDelSurround(\"" << test[i][source] 
			<< "\") = \"" << s << "\"" << endl;
	if (s != test[i][surr])
	{
	    cout << "- Error in STLStringDelSurround(\"" << test[i][source] 
		 << "\"):\n  is \"" << s << "\", should be \"" <<
		 test[i][surr] << "\"" << endl;
	    errnum[surr-1]++;
	}
    }

    //----------------------
    // print test results :
    //----------------------
    cout << "Test Results:" << endl;

    cout << "- STLStringDelFollow()    : ";
    if (errnum[foll-1]) cout << errnum[foll-1] << " error(s)" << endl;
    else		cout << "okay" << endl;

    cout << "- STLStringDelLead()      : ";
    if (errnum[lead-1]) cout << errnum[lead-1] << " error(s)" << endl;
    else		cout << "okay" << endl;

    cout << "- STLStringDelSurround()  : ";
    if (errnum[surr-1]) cout << errnum[surr-1] << " error(s)" << endl;
    else		cout << "okay" << endl;

    // count all errors:
    unsigned int allErrNum = 0;
    for (i = 0; i < sizeof(errnum)/sizeof(errnum[0]); i++)
	allErrNum += errnum[i];

    if (allErrNum)
	cout << "Stop. " << allErrNum << " error" 
	     << (allErrNum > 1 ? "s":"") << " found in " 
	     << testnum << " tests by " << argv[0] 
	     << "!" << endl;
    else
	cout << "Okay: no errors found in " << testnum << " tests." << endl;
    return (allErrNum ? 1 : 0);
}

